/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcaudiovideoconfigpage.h"

#include "../../kdcconfig.h"

#include <QStringList>
#include <QLabel>
#include <QHBoxLayout>
#include <QVBoxLayout>

#include <KLocale>

KDCAudioVideoConfigPage::KDCAudioVideoConfigPage( QWidget * parent )
	: QWidget( parent )
{
	QVBoxLayout *mainLayout = new QVBoxLayout( this );
	QHBoxLayout *hLayout = new QHBoxLayout;
	QLabel *label = new QLabel( i18n("Video driver:") );
	kcfg_Driver = new KComboBox;
	QStringList list;
	list << "xv" << "x11" << "gl" << "gl2" << "sdl" << "directfb";
	kcfg_Driver->addItems( list );
	hLayout->addWidget( label );
	hLayout->addWidget( kcfg_Driver );
	mainLayout->addLayout( hLayout );
	mainLayout->addStretch();
}

KDCAudioVideoConfigPage::~KDCAudioVideoConfigPage()
{

}

void KDCAudioVideoConfigPage::readConfig()
{
	kcfg_Driver->setCurrentIndex( kcfg_Driver->findText( KDCConfig::driver() ) );
}

void KDCAudioVideoConfigPage::saveSettings()
{
	KDCConfig::setDriver( kcfg_Driver->itemText( kcfg_Driver->currentIndex() ) );
}
