/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcprogressdialog.h"

#include "../kdcfilefactory.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QDebug>

#include <KLocale>
#include <KIcon>

KDCProgressDialog::KDCProgressDialog( QWidget *parent )
	: KProgressDialog( parent, i18n("Adding selected files") )
{
	p_mainTitle = new KDCLabel( KDCLabel::TITLE );
	p_error = new KDCLabel( i18n("Error"), Qt::red, KDCLabel::TITLE );
	p_error->hide();
	p_errorMessage = new KDCLabel;
	p_errorMessage->hide();
	QLayout *vLayout = qobject_cast<QLayout*>( layout() );
	qDebug() << vLayout;
	//vLayout->insertWidget( 0, p_mainTitle );
	//vLayout->addWidget( p_error );
	//vLayout->addWidget( p_errorMessage );

	p_closeButton = new KPushButton( KIcon("dialog-close"), i18n("Close") );
	p_closeButton->hide();
	connect( p_closeButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
	QHBoxLayout *hLayout = new QHBoxLayout;
	hLayout->addStretch();
	hLayout->addWidget( p_closeButton );

	//vLayout->addLayout( hLayout );

	setAllowCancel( FALSE );
	setModal( TRUE );
	setWindowModality( Qt::ApplicationModal );

	setWindowIcon( KDCFileFactory::appIcon() );
}

KDCProgressDialog::~KDCProgressDialog()
{

}

void KDCProgressDialog::setMainTitle( const QString& title )
{
	p_mainTitle->setText( title );
}

void KDCProgressDialog::setSubTitle( const QString& title )
{
	setLabelText( title );
}

void KDCProgressDialog::closeEvent( QCloseEvent *event )
{
	event->ignore();
}

void KDCProgressDialog::setError( const QString& error )
{
	p_error->show();
	p_errorMessage->setText( error );
	p_errorMessage->show();
	p_closeButton->show();
}
