/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCBUILDALLCOMPOSITEJOB_H
#define KDCBUILDALLCOMPOSITEJOB_H

#include "../kdcdvddisc.h"
#include "../dialogs/kdcoutputdialog.h"
#include "kdccompositejob.h"
#include "kdccpuinfojob.h"

#include <QList>
#include <QPointer>

class QTreeWidgetItem;

class KDCBuildAllCompositeJob : public KDCCompositeJob
{
Q_OBJECT
public:
	KDCBuildAllCompositeJob( const QList<KDCDisc*>& list, QObject *parent = 0 );
	~KDCBuildAllCompositeJob();
	void start();
	KDialog* dialog() const;
signals:
	void processingMovieChanged( QTreeWidgetItem *movie );
	void done();
private slots:
	void on_jobFinished( KDCJob * );
	void on_jobProgress( int );
	void on_jobSpeed( double );
	void on_jobInfoMessage( const QString& );
	void on_jobTotalSize( int );
	void on_jobPercent( int );
	void on_discInfoMessage( const QString& , quint64 );
	void on_jobErrorMessage( const QString& );
	void on_movieChanged( QTreeWidgetItem * );
	void on_jobMainProgram( const QString& );
private:
	KDCOutputDialog *p_dlg;
	QPointer<KDCCpuInfoJob> p_cpuInfo;
};
#endif
