/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCBUILDDISCCOMPOSITEJOB_H
#define KDCBUILDDISCCOMPOSITEJOB_H

#include "../kdcdisc.h"
#include "kdccompositejob.h"

#include <QString>
#include <QTreeWidgetItem>
#include <QList>

class KDCBuildDiscCompositeJob: public KDCCompositeJob
{
Q_OBJECT
public:
	KDCBuildDiscCompositeJob( KDCDisc *disc, QObject *parent = 0 );
	~KDCBuildDiscCompositeJob();
	void start();
signals:
	void discInfoMessage( const QString& outputPath, quint64 size );
	void movieChanged( QTreeWidgetItem *movie );
private slots:
	void on_jobFinished( KDCJob * );
private:
	KDCDisc *p_disc;
	QList<QTreeWidgetItem*> p_movies;
};
#endif
