/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCFILEFACTORY_H
#define KDCFILEFACTORY_H

#include "kdcdisc.h"

#include <QTreeWidgetItem>
#include <QString>
#include <QMap>

#include <KIcon>

class KDCFileFactory
{
public:
	static void setInitializeInfo( const QString& appsPath );
	static void clean();
	static const QString logFileName();
	static void addLogInfo( const char *msg );

	static KIcon appIcon();
	static const QString appTempPath();

	static const QString discDirectory( const KDCDisc *disc );
	static const QString discOutputDirectory( const KDCDisc *disc );
	static const QString discConfigFile( const KDCDisc *disc );

	static const QString movieName( const KDCMovie *movie );
	static const QString movieFrame( const KDCMovie *movie );
	static const QString movieSubtitleFile( const KDCMovie *movie, int id );
	static const QString movieSubtitleConfigFile( const KDCMovie *movie, int id );
	static const QString movieDir( const KDCMovie *movie );

	static const QString movieName( const KDCMovieGroup *movie );
	static const QString movieFrame( const KDCMovieGroup *movie );
	static const QString movieSubtitleFile( const KDCMovieGroup *movie, int id );
	static const QString movieSubtitleConfigFile( const KDCMovieGroup *movie, int id );
	static const QString movieDir( const KDCMovieGroup *movie );

	// other helper functions
	static bool createDirectory( const QString& path );
	static void removeDirectory( const QString& path );
	static bool removeFile( const QString& path );
	static bool renameFile( const QString& oldName , const QString& newName );
	//static qint64 directorySizeInMB( const QString& path );

	static const QString mountPoint( const QString& path );

	static QString readAll( const QString& file );
	static const QString fileName( const QString& path );
	static const QString baseFileName( const QString& path );
	static const QString filePath( const QString& path );
	static const QString fileNameWithoutExtension( const QString& path );
private:
	static QString p_appsTempPath;
	static QString p_appsLogFileName;
};
#endif
