/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCNAMESPACE_H
#define KDCNAMESPACE_H

#include <Qt>

#ifndef Q_MOC_RUN
namespace
#else
class Q_CORE_EXPORT
#endif
KDC {
#ifdef Q_MOC_RUN
	Q_OBJECT	
	Q_ENUMS ( Object );
	Q_ENUMS ( VideoFormat );
	Q_ENUMS ( DeinterlaceMode );
	Q_ENUMS ( MacroBlockMode );
	Q_ENUMS ( AspectRatio );
	Q_ENUMS ( AudioCodec );
	Q_ENUMS ( StreamMode );
	Q_ENUMS ( MediaSize );
	Q_ENUMS ( Mode );
	Q_ENUMS ( DiscType );
	Q_ENUMS ( VideoCodec );
	Q_ENUMS ( ViewMode );
public:
#endif
	enum Object { VTS = 1001, VMGMenu = 1002, Movie = 1003, MovieInfo = 1004, MovieGroup = 1005,
								Subtitles = 1006, SubtitleGroup = 1007 };
	enum VideoFormat { PAL = 0, NTSC = 1 };
	enum VideoCodec { mpeg1, mpeg2, IncorrectVideoCodec };
	enum DeinterlaceMode { None, Linear, Median, FFmpeg };
	enum DiscType { DVD, VCD, SVCD, CVD };
	enum MacroBlockMode { MBCMP = 0, MDB1 = 1, MDB2 = 2 };
	enum AspectRatio { LetterBox = 0, WideScreen = 1 };
	enum AudioCodec { MP2, AC3, IncorrectAudioCodec };
	enum StreamMode { Copy, Resample };
	enum MediaSize { CD700 = 716800, CD800 = 819200, DVD47 = 4928307, DVD8 = 8388608 };
	enum Mode { Enabled, Disabled };
	enum ViewMode { Icon, List };
};
#endif
