/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCVIDEOSTREAMMETADATA_H
#define KDCVIDEOSTREAMMETADATA_H

#include <QString>

class KDCVideoStreamMetaData
{
public:
	KDCVideoStreamMetaData(	const QString& demuxer,
													const QString& codec,
													const int width,
													const int height,
													const int bitrate,
													const double fps,
													const double length,
													const double aspect );
	QString demuxer() const;
	int width() const;
	int height() const;
	int bitrate() const;
	double fps() const;
	int length() const;
	QString codec() const;
	double aspectRatio() const;
	int frameCount() const;
private:
	QString p_demuxer;
	int p_bitrate;
	int p_height;
	int p_width;
	double p_fps;
	double p_aspect;
	int p_length;
	QString p_codec;
	int p_frameCount;
};
#endif
