/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcvts.h"

#include <QTreeWidgetItemIterator>

#include <KLocale>
#include <KIcon>

KDCVTS::KDCVTS( QTreeWidgetItem *parent ) 
	: QTreeWidgetItem( parent, KDC::VTS )
{
	setTextAlignment( 1, Qt::AlignHCenter | Qt::AlignVCenter );
	setIcon( 0, KIcon("folder-video") );
	setFlags( Qt::ItemIsEnabled | Qt::ItemIsDragEnabled | Qt::ItemIsDropEnabled );
	refresh();
}

KDCVTS::~KDCVTS()
{

}

QList<QTreeWidgetItem*> KDCVTS::movies()
{
	QList<QTreeWidgetItem*> list;
	for ( int i=0; i<childCount(); ++i )
		list.append( child( i ) );
	return list;
}

void KDCVTS::refresh()
{
	if ( childCount() > 0 )
		setText( 0, i18n("Video Title Set ( %1 )").arg( childCount() ) );
	else
		setText( 0, i18n("Video Title Set") );
}
