/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcaudiochanneldelegate.h"

#include "kdcaudiochannelcombobox.h"

#include <QModelIndex>

KDCAudioChannelDelegate::KDCAudioChannelDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	p_id = 0;
	p_movie = NULL;
}

void KDCAudioChannelDelegate::setCurrentData( const KDCMovie *movie, int id )
{
	p_movie = movie;
	p_id = id;
}

QWidget* KDCAudioChannelDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KDCAudioChannelComboBox *editor = new KDCAudioChannelComboBox( p_movie, p_id, parent );
	connect( editor, SIGNAL( currentChannelChanged( int ) ), this, SLOT( on_channelChanged( int ) ) );
	return editor;
}

void KDCAudioChannelDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KDCAudioChannelComboBox *tmp = static_cast<KDCAudioChannelComboBox*>( editor );
	model->setData( index, tmp->currentText() );
}

void KDCAudioChannelDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCAudioChannelDelegate::on_channelChanged( int count )
{
	emit channelChanged( count );
}
