/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcaudiocodecdelegate.h"

#include "kdcaudiocodeccombobox.h"

#include <QModelIndex>

KDCAudioCodecDelegate::KDCAudioCodecDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	p_movie= NULL;
	p_id = 0;
}

void KDCAudioCodecDelegate::setCurrentData( const KDCMovie *movie, int id )
{
	p_movie = movie;
	p_id = id;
}

QWidget* KDCAudioCodecDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KDCAudioCodecComboBox *editor = new KDCAudioCodecComboBox( p_movie, p_id, parent );
	connect( editor, SIGNAL( currentCodecChanged( KDC::AudioCodec ) ), this, SLOT( on_codecChanged( KDC::AudioCodec ) ) );
	return editor;
}

void KDCAudioCodecDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KDCAudioCodecComboBox *tmp = static_cast<KDCAudioCodecComboBox*>( editor );
	model->setData( index, tmp->currentText() );
}

void KDCAudioCodecDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCAudioCodecDelegate::on_codecChanged( KDC::AudioCodec codec )
{
	emit codecChanged( codec );
}
