/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcvideocodeccombobox.h"

#include "../../kdcdisc.h"

KDCVideoCodecComboBox::KDCVideoCodecComboBox( const KDCMovie *movie, QWidget *parent )
	: KComboBox( parent )
{
	if ( movie->disc()->discType() == KDC::DVD )
	{
		addItem( "MPEG-1", KDC::mpeg1 );
		addItem( "MPEG-2", KDC::mpeg2 );
	}
	else
		if ( movie->disc()->discType() == KDC::VCD )
			addItem( "MPEG-1", KDC::mpeg1 );
	else
		addItem( "MPEG-2", KDC::mpeg2 );

	setCurrentIndex( findData( movie->videoStream()->codec() ) );
	connect( this, SIGNAL( currentIndexChanged( int ) ), this, SLOT( on_currentIndexChanged( int ) ) );
}

KDCVideoCodecComboBox::~KDCVideoCodecComboBox()
{

}

KDC::VideoCodec KDCVideoCodecComboBox::currentCodec() const
{
	if ( currentText() == "MPEG-1" )
		return KDC::mpeg1;
	else
		return KDC::mpeg2;
}

void KDCVideoCodecComboBox::on_currentIndexChanged( int )
{
	emit currentCodecChanged( currentCodec() );
}
