/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdcvideoformatdelegate.h"

#include "kdcvideoformatcombobox.h"

#include <QModelIndex>

KDCVideoFormatDelegate::KDCVideoFormatDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	
}

void KDCVideoFormatDelegate::setCurrentData( KDC::VideoFormat format )
{
	p_format = format;
}

KDC::VideoFormat KDCVideoFormatDelegate::currentFormat() const
{
	return p_format;
}

QWidget* KDCVideoFormatDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KDCVideoFormatComboBox *editor = new KDCVideoFormatComboBox( p_format, parent );
	connect( editor, SIGNAL( currentFormatChanged( KDC::VideoFormat ) ), this, SLOT( on_formatChanged( KDC::VideoFormat ) ) );
	//editor->installEventFilter( const_cast<KDCVideoFormatDelegate*>( this ) );
	return editor;
}

void KDCVideoFormatDelegate::setEditorData( QWidget *editor, const QModelIndex& index ) const
{
	KDCVideoFormatComboBox *tmp = static_cast<KDCVideoFormatComboBox*>( editor );
	tmp->setCurrentFormat( p_format );
}

void KDCVideoFormatDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KDCVideoFormatComboBox *tmp = static_cast<KDCVideoFormatComboBox*>( editor );
	model->setData( index, tmp->currentText() );
}

void KDCVideoFormatDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCVideoFormatDelegate::on_formatChanged( KDC::VideoFormat format )
{
	p_format = format;
	emit formatChanged( format );
}
