/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCMOVIELIST_H
#define KDCMOVIELIST_H

#include "../../kdcmovie.h"
#include "../../kdcmoviegroup.h"

#include <QMouseEvent>
#include <QStringList>
#include <QPointer>
#include <QTreeWidgetItem>
#include <QTreeWidget>

class KDCMovieList : public QTreeWidget
{
Q_OBJECT
public:
	KDCMovieList( QWidget *parent = 0 );
	~KDCMovieList();
	void setCurrentMovie( KDCMovie *movie );
	void setCurrentMovie( KDCMovieGroup *movie );
	KDCMovie* currentMovie() const;
public slots:
	void clean();
signals:
	void currentMovieChanged( KDCMovie * movie );
private slots:
	void on_currentItemChanged( QTreeWidgetItem *, QTreeWidgetItem * );
protected:
	QStringList mimeTypes() const;
	Qt::DropActions supportedDropActions() const;
	void mouseMoveEvent( QMouseEvent *event );
	bool dropMimeData( QTreeWidgetItem *parent, int index, const QMimeData *data, Qt::DropAction action );
private:
	QPointer<KDCMovieGroup> p_group;
	QPointer<KDCMovie> p_movie;
};
#endif
