/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kdctextsizedelegate.h"

#include <QModelIndex>

#include <KIntSpinBox>

KDCTextSizeDelegate::KDCTextSizeDelegate( QObject *parent )
	: QItemDelegate( parent )
{
	
}

void KDCTextSizeDelegate::setCurrentData( int size )
{
	p_size = size;
}

int KDCTextSizeDelegate::currentSize() const
{
	return p_size;
}

QWidget* KDCTextSizeDelegate::createEditor( QWidget *parent, const QStyleOptionViewItem& option, const QModelIndex& index ) const
{
	KIntSpinBox *editor = new KIntSpinBox( parent );
	connect( editor, SIGNAL( valueChanged( int ) ), this, SLOT( on_valueChanged( int ) ) );
	editor->setRange( 10, 40 );
	//editor->installEventFilter( const_cast<KDCTextSizeDelegate*>( this ) );
	return editor;
}

void KDCTextSizeDelegate::setEditorData( QWidget *editor, const QModelIndex& index ) const
{
	KIntSpinBox *tmp = static_cast<KIntSpinBox*>( editor );
	tmp->setValue( p_size );
}

void KDCTextSizeDelegate::setModelData( QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
	KIntSpinBox *tmp = static_cast<KIntSpinBox*>( editor );
	tmp->interpretText();
	model->setData( index, tmp->value() );
}

void KDCTextSizeDelegate::updateEditorGeometry( QWidget *editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
	editor->setGeometry( option.rect );
}

void KDCTextSizeDelegate::on_valueChanged( int val )
{
	p_size = val;
	emit sizeChanged( val );
}
