/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCQUALITYEDITOR_H
#define KDCQUALITYEDITOR_H

#include "../../kdcmovie.h"
#include "../../kdcmoviegroup.h"
#include "kdcvideoqualitydelegate.h"

#include <QTreeWidget>
#include <QResizeEvent>
#include <QMap>
#include <QPointer>

class KDCQualityEditor : public QTreeWidget
{
Q_OBJECT
public:
	KDCQualityEditor( QWidget *parent = 0 );
	~KDCQualityEditor();
	void setCurrentMovie( KDCMovie *movie );
	void setCurrentMovie( KDCMovieGroup *movie );
public slots:
	void clean();
	void readMovieSettings();
private slots:
	void openEditor( QTreeWidgetItem *, int );
	void on_closeEditor( QWidget *, QAbstractItemDelegate::EndEditHint );
	void on_macroBlockModeChanged( KDC::MacroBlockMode );
	void on_deinterlaceModeChanged( KDC::DeinterlaceMode );
	void on_itemClicked( QTreeWidgetItem * , int );
protected:
	void resizeEvent( QResizeEvent *event );
private:
	QPointer<KDCMovie> p_movie;
	QMap<int, QString> p_macroMap;
	QMap<int, QString> p_deintMap;
	KDCVideoQualityDelegate *p_macroDelegate;
	KDCVideoQualityDelegate *p_deintDelegate;
};
#endif
