/***************************************************************************
 *   Copyright (C) 2007 by Marcin Swiechowicz   *
 *   marcin.swiechowicz@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KDCVIDEOQUALITYDELEGATE_H
#define KDCVIDEOQUALITYDELEGATE_H

#include "../../kdcmovie.h"

#include <QItemDelegate>

class KDCVideoQualityDelegate : public QItemDelegate
{
Q_OBJECT
public:
	enum Mode { MacroBlock = 1, Deinterlace = 2 };
	KDCVideoQualityDelegate( KDCVideoQualityDelegate::Mode mode, QObject *parent = 0 );
	void setCurrentData( const KDCMovie *movie );
	QWidget * createEditor ( QWidget * parent, const QStyleOptionViewItem & option, const QModelIndex & index ) const;
	void setEditorData(QWidget *editor, const QModelIndex &index) const;
	void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;
	void updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const;
signals:
	void macroBlockModeChanged( KDC::MacroBlockMode mode );
	void deinterlaceModeChanged( KDC::DeinterlaceMode mode );
private slots:
	void on_currentMacroBlockModeChanged( KDC::MacroBlockMode );
	void on_currentDeinterlaceModeChanged( KDC::DeinterlaceMode );
private:
	const KDCMovie *p_movie;
	KDCVideoQualityDelegate::Mode p_mode;
};
#endif
